function Task(arguments, _function) {
  this._arguments = arguments;
  this._function = _function;
}

Task.prototype = {

  invoke : function () {
    this._function(this._arguments);
  }

};


function Process() {
  this._key = Process.registry.length;
  Process.registry[this._key] = this;

  this._tasks = Array();
  this._tasksIndex = 0;
}

Process.registry = new Array();

Process.prototype = {
  run : function () {
    setInterval('Process.registry[' + this._key + '].tick()', 100);
  },

  tick : function () {
    if ("object" == (typeof this._tasks[this._tasksIndex])) {
      this._tasks[this._tasksIndex].invoke();
      this._tasksIndex++;
    }
  },

  addTask : function (task) {
    this._tasks[this._tasks.length] = task;
  }

};

function updateProgressBar() {
  progressBar.getController().inc();
}